PROGRAM exampl3
!
!     THIS PROGRAM EXECUTES THE EXAMPLE PROBLEM THREE OF THE CONMIN MANUAL

! Code converted using TO_F90 by Alan Miller
! Date: 2001-06-16  Time: 18:36:50
 
USE Constrained_minimization
USE common_cnmn1
IMPLICIT NONE
INTEGER, PARAMETER  :: dp = SELECTED_REAL_KIND(12, 60)

REAL (dp)  :: s(4), g1(10), g2(10), b(10,10), c(10), vlb(4), vub(4),  &
              scal(4), df(4), a(4,10)
INTEGER    :: ms1(20), isc(10), ic(10)

! COMMON /varable/ aobj, x(6), g(11)
REAL (dp)  :: aobj, x(6), g(11)

! COMMON /andata/ loopcnt

! COMMON /grad/ isc(11), ic(11), df(6), a(6,11)

! COMMON /consav/ rnum(50), inum(25)

INTEGER    :: i, n1, n2, n3, n4, n5, nlim
REAL (dp)  :: phi

NAMELIST /conpar/ infog, info, nfdg, iprint, ndv, itmax, ncon,  &
    nside, icndir, nscal, fdch, fdchm, ct, ctmin, ctlmin, theta,  &
    phi, delfun, dabfun, linobj, itrm, x, vlb, vub, n1, n2, n3,  &
    n4, n5, alphax, abobj1, ctl, isc, scal
!
OPEN (UNIT=6,FILE='EXOUT3.TXT',STATUS='NEW')
!
!
!  INITIALIZE
!
infog = 0
info = 0
nfdg = 2
iprint = 1
ndv = 2
itmax = 40
ncon = 6
nside = 1
icndir = 0
nscal = 0
fdch = 0.0
fdchm = 0.0
ct = 0.0
ctmin = 0.0
ctl = 0.0
ctlmin = 0.0
theta = 0.0
phi = 0.0
delfun = 0.0
dabfun = 0.0
linobj = 1
itrm = 0
n1 = 4
n2 = 10
n3 = 10
n4 = 10
n5 = 20
alphax = 0.0
abobj1 = 0.0
ctl = 0.0
DO  i = 1, ndv
  x(i) = 1.0
  vlb(i) = 0.001
  vub(i) = 1.0E+10
END DO
!
isc(1:ncon) = 0
!
!     READ THE PARAMETERS FOR CONMIN
!
!CC   READ(5,CONPAR)      USE DEFAULT VALUES
WRITE (6,conpar)
nlim = itmax * (ndv+5)
!
!     NON-ITERATIVE PART OF ANALYSIS
!
igoto = 0
!
!     ITERATIVE PART OF ANALYSIS
!
DO  i = 1, nlim
!
!       CALL THE OPTIMIZATION ROUTINE CONMIN
!
  CALL conmin(x,vlb,vub,g,scal,df,a,s,g1,g2,b,c,isc,ic,ms1,n1,n2,n3,n4,n5)
!
!
!       ANALYSIS MODULE
!
  CALL analys()
  obj = aobj
  IF (igoto == 0) EXIT
END DO
!
!
CLOSE (6)
STOP


CONTAINS


SUBROUTINE analys()
!
!   ROUTINE TO CALCULATE OBJECTIVE FUNCTION AND CONSTRAINT VALUES
!   FOR OPTIMIZATION OF CONSTRAINED ROSEN-SUZUKI FUNCTION.
!
!
REAL (dp)  :: a1, a2, denom, rho, sig11, sig21, sig31

rho = 0.1
a1 = x(1)
a2 = x(2)
!
IF (info < 2) THEN
!
!  OBJECTIVE FUNCTION
!
  aobj = 10. * rho * (2.*SQRT(2.)*a1+a2)
!
!
!   CONSTRAINT VALUES
!
  denom = 2. * a1 * a2 + SQRT(2.) * a1 * a1
  sig11 = 20. * (SQRT(2.)*a1+a2) / denom
  sig21 = 20. * SQRT(2.) * a1 / denom
  sig31 = -20. * a2 / denom
!
  g(1) = -sig11 / 15. - 1.
  g(2) = sig11 / 20. - 1.
  g(3) = -sig21 / 15. - 1.
  g(4) = sig21 / 20. - 1.
  g(5) = -sig31 / 15. - 1.
  g(6) = sig31 / 20. - 1.
!
ELSE
!
!
!    GRADIENT INFORMATION
!
  df(1) = 20. * SQRT(2.) * rho
  df(2) = 10. * rho
END IF
!
!  GRADIENTS OF ACTIVE AND VIOLATED CONSTRAINTS
!  WILL BE CALCULATED BY FINITE DIFFERENCE WITHIN
!  CONMIN
!
!
RETURN
END SUBROUTINE analys

END PROGRAM exampl3

